-- AutoGraph
-- Automatically changes graphics detail depending on zone or instance.

AutoGraph = LibStub("AceAddon-3.0"):NewAddon("AutoGraph", "AceEvent-3.0")

-- .-------------------------------------------------------------------------------.
-- |  Functions                                                                    |
-- '-------------------------------------------------------------------------------'

local _, lakename, _, _, _, _ = GetWorldPVPAreaInfo(1)
local _, baradname, _, _, _, _ = GetWorldPVPAreaInfo(2)

function AutoGraph:OnEnable()
	self:RegisterEvent("PLAYER_ENTERING_WORLD","WereZoned")
	self:RegisterEvent("ZONE_CHANGED","WereZoned")
end

function AutoGraph:RaidUpdated()
	local raidMembers = GetNumRaidMembers()
	if ((GetRealZoneText() == lakename) or (GetRealZoneText() == baradname)) then
		SetCVar("particleDensity", 15)
		return
	elseif (raidMembers > 25) then
		SetCVar("particleDensity", 30)
		return
	elseif (raidMembers > 15) then
		SetCVar("particleDensity", 50)
		return
	elseif (raidMembers > 10) then
		SetCVar("particleDensity", 70)
		return
	elseif (raidMembers == 0 or raidMembers > 0) then
		SetCVar("particleDensity", 100)
		return
	end
end



-- .-------------------------------------------------------------------------------.
-- |  Helper functions                                                             |
-- '-------------------------------------------------------------------------------'

function AutoGraph:WereZoned()
	local _, instanceType = IsInInstance()
	if (instanceType == "raid" or instanceType == "pvp" or (GetRealZoneText() == lakename) or (GetRealZoneText() == baradname)) then
		self:RegisterEvent("RAID_ROSTER_UPDATE","RaidUpdated")
		self:RaidUpdated()
	else
		self:UnregisterEvent("RAID_ROSTER_UPDATE")
		SetCVar("particleDensity", 100)
	end
end